
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


/***********************************************************************
***                                                                  ***
***       (C) COPYRIGHT IBM CORP  1997                               ***
***                                                                  ***
***       LICENSED MATERIALS  -  PROPERTY OF IBM                     ***
***                                                                  ***
***       All Rights Reserved                                        ***
***                                                                  ***
***       U.S. Government Users Restricted Rights - Use,             ***
***       duplication or disclosure restricted by GSA ADP            ***
***       Schedule Contract with IBM Corp.                           ***
***                                                                  ***
***                                                                  ***
***       ORIGINS: RES (IBM Research Division)                       ***
***                                                                  ***
************************************************************************
*
* Module Name:       mp_util.c
*
* Descriptive Name:  Public Key cryptographic Algorithm manager (PKA_MGR)
*                    Multi-Precision manipulation utilities
*
* Status:            Release 1 Version 1
*
* Function:          Multi-Precision manipulation utilities
*
*
* Module type:
*      Processor:    Intel x86 family
*
*      Language:     C source
*
*      Compiler:     IBM VisualAge on OS/2
*
* Restrictions:
*
* Linkage:           these routines are part of the PKA manager
*
*
*
* Change History:    written January 1997 by Pankaj Rohatgi
*                    IBM Research, Hawthorne, NY
*
*
*   Date    Ver   Notes                                            by
* --------- ----  -----                                            ---
* 01-Jan-97       initial implementation                           PR
* 10-Oct-97       added conversion routines                        SC
* 08-Mar-99      -Modified mp_extend to improve performance        jgd
*                 when LITTLE_ENDIAN
*                -Modified mp_compare_general to improve performance
*                -Modified mp_copy_unit_lsb to improve performance
*                 when LITTLE_ENDIAN
*                -Modified mp_copy_unit_msb to improve performance
*                 when LITTLE_ENDIAN
* 08-Mar-99       profiling                                        jgd
***********************************************************************/
#ifndef __PROFILE__
#define __PROFILE__ 0
#endif
#include "profiler.h"

#include <string.h>   /* for memcpy... */

#include "platform.h"
#include "mpmath.h"

int mp_truesize(mp_int *a)
{
    P_ENTER( P_mp_truesize )

    int i = a->size;
    unit *msb = MP_MS_UNIT(a);


    while ( (i) && (!(*msb)))
    {
        i--;
        UNIT_PLUS_PLUS(msb);
    }

    P_LEAVE( P_mp_truesize )
    return(i);
}

/*
******************************************************************************
  mp_normalize

  INPUT: mp_int *a :  Pointer to an mp_int
  OUTPUT: void

  Side effects. The mp_int is normalized. I.e., either the size = 0 or
  the unit pointed to by a->value is nonzero.

******************************************************************************
*/

void mp_normalize(mp_int *a)
{
  P_ENTER( P_mp_normalize )

  int size = a->size;
  unit *msunit = MP_MS_UNIT(a);

  if (!size) { P_LEAVE(P_mp_normalize)  return; }
  if (*msunit) { P_LEAVE(P_mp_normalize)  return; }
  while (size)
  {
    if (*msunit)
      break;
    else
    {
      PLUS_PLUS_UNIT(msunit);
      --size;
    }
  }

  if (size == 0)
  {
    a->size=0;
  }
  else
  {
    a->size = size;
#ifdef __BIG_ENDIAN__
    {
        unit *first_unit = MP_MS_UNIT(a);

        /* Data movement required  if we have big endian architecture */
        do
        {
            *(UNIT_PLUS_PLUS(first_unit)) = *(UNIT_PLUS_PLUS(msunit));
        }while(--size);
    }
#endif /* __BIG_ENDIAN__ */

  }
  P_LEAVE( P_mp_normalize )
}

int mp_extend(mp_int *a, int size)
{
  P_ENTER( P_mp_extend )

  /* See if anything at all is needed */
  if (a->size != size)
  {
#ifdef __BIG_ENDIAN__
    unit *s, *t;
    int i,j;
#endif
    if (a->maxsize < size)
      { P_LEAVE( P_mp_extend ) return PKAMathFail; }
    if (a->size > size)
    {
      mp_normalize(a);
      if( a->size > size )
        { P_LEAVE( P_mp_extend ) return PKAMathFail; }
    }
    /* This works for both little and big endian, for little endian
       is still important to put o's in MSBs
    */
#ifdef __BIG_ENDIAN__
    s = MP_LS_UNIT(a);
    i = a->size;
    j = size - a->size;
    a->size = size;
    t = MP_LS_UNIT(a);
    while (i--)
      *UNIT_MINUS_MINUS(t) = *UNIT_MINUS_MINUS(s);
    while (j--)
      *UNIT_MINUS_MINUS(t) = 0;
#else
    memset( a->value + a->size /*older smaller size*/, 0, sizeof(unit)*(size - a->size) );
    a->size = size;
#endif
    P_LEAVE( P_mp_extend )
    return 0;
  }
  P_LEAVE( P_mp_extend )
  return 0;

}

/*
****************************************************************************
 mp_compare_fast.

 Input : msb_a : pointer to MS unit of an mp_int a
         msb_b : pointer to MS unit of an mp_int b
         size  : common size of the mp's
 Output:
     0   ->  a == b
    -1   ->  a < b
     1   ->  a > b

****************************************************************************
*/

int mp_compare_fast(unit *msb_a, unit *msb_b, int size)
{
  P_ENTER( P_mp_compare_fast )
  if (!size) { P_LEAVE( P_mp_compare_fast ) return 0; }
  do
  {
    if ((*(UNIT_PLUS_PLUS(msb_a))) != (*(UNIT_PLUS_PLUS(msb_b))))
      break;
  }while(--size);

  if (size)
  {
    if ( (*(MINUS_MINUS_UNIT(msb_a))) > (*(MINUS_MINUS_UNIT(msb_b))))
      { P_LEAVE( P_mp_compare_fast ) return 1; }
    else
      { P_LEAVE( P_mp_compare_fast ) return -1; }
  }
  else
    { P_LEAVE( P_mp_compare_fast ) return 0; }
}

/*
****************************************************************************
 mp_compare_general

 Input : a     : pointer MSB of an mp_int a
         msb_b : MSB of an mp_int b
         size  : common size of the mp's
 Output:
     0   ->  a == b
    -1   ->  a < b
     1   ->  a > b

****************************************************************************
*/

int mp_compare_general(mp_int *a, mp_int *b)
{
  P_ENTER( P_mp_compare_general )

  int realsize_a, realsize_b; /* Normalized size of a,b */

  realsize_a = mp_truesize( a );
  realsize_b = mp_truesize( b );

  if( realsize_a > realsize_b )
  {
     P_LEAVE( P_mp_compare_general )
     return 1;
  }
  else
  {
    if( realsize_a < realsize_b )
    {
      P_LEAVE( P_mp_compare_general )
      return -1;
    }
    else
    {
       unit *real_msa   = MS_UNIT(a->value,realsize_a);
       unit *real_msb   = MS_UNIT(b->value,realsize_b);
       #if(__PROFILE__)
       {
         int  retval = mp_compare_fast(real_msa, real_msb, realsize_a);
         P_LEAVE( P_mp_compare_general )
         return retval;
       }
       #else
         return (mp_compare_fast(real_msa, real_msb, realsize_a));
       #endif
    }
  }
}
/*
****************************************************************************
 mp_copy_unit_lsb

 Input : result_lsb    : pointer to LSB of destination mp_int
         input_lsb     : pointer to LSB of source mp_int
         size  :      size of the mp being copied
 Output:
     void

****************************************************************************
*/
void mp_copy_unit_lsb(unit *result_lsb, unit *input_lsb, int size)
{
  P_ENTER( P_mp_copy_unit_lsb )
#ifdef __LITTLE_ENDIAN__
  /* trying this for performance... */
  memcpy( result_lsb, input_lsb, sizeof(unit)*size );
#else
  while(size--)
  {
    *(UNIT_MINUS_MINUS(result_lsb)) = *(UNIT_MINUS_MINUS(input_lsb));
  }
#endif
  P_LEAVE( P_mp_copy_unit_lsb )
}

/*
****************************************************************************
 mp_copy_unit_msb

 Input : result_msb    : pointer to MSB of destination mp_int
         input_msb     : pointer to MSB of source mp_int
         size  :      size of the mp being copied
 Output:
     void

****************************************************************************
*/

void mp_copy_unit_msb(unit *result_msb, unit *input_msb, int size)
{
  P_ENTER( P_mp_copy_unit_msb )
#ifdef __LITTLE_ENDIAN__
  if( size )
  {
     memcpy( result_msb - (size-1), input_msb - (size-1), sizeof(unit)*size );
  }
#else
  while(size--)
  {
    *(UNIT_PLUS_PLUS(result_msb)) = *(UNIT_PLUS_PLUS(input_msb));
  };
#endif
  P_LEAVE( P_mp_copy_unit_msb )
}

/*
****************************************************************************
 mp_copy

 Input : result    : pointer to destination mp_int
         input     : pointer to source mp_int
 Output:
     0: success
     -1: result not big enough to hold input. In this
         case a partial copy is carried out (LSB's
         are copied).
****************************************************************************
*/

int mp_copy(mp_int *result, mp_int *input)
{
    P_ENTER( P_mp_copy )

    int res = 0;
    int inputsize = mp_truesize(input);

    if (result->maxsize < inputsize)
    {   res = PKAMathFail;
        result->size = result->maxsize;

    }
    else
    {   res = 0;
        result->size = inputsize;
    }
    mp_copy_unit_lsb(MP_LS_UNIT(result), MP_LS_UNIT(input), result->size);

    P_LEAVE(P_mp_copy)
    return(res);
}

/* Added the following routines previously found in rsa files [ sc ] */
/*--------------------------------------------------------------------------
  mpint_to_bigendian_bytearray

  INPUT: msb of the integer to be converted to a byte array
         size of the mp int
         external pointer to buffer to hold the byte array.
         external_byte_size size of the external buffer.

  NOTE: It only fills out as many bytes that the external
        buffer will take.
----------------------------------------------------------------------------*/
void mpint_to_bigendian_bytearray(unit *msb_internal,
                                  int internal_size,
                                  unsigned char *external,
                                  int external_byte_size)
{
  P_ENTER( P_mpint_to_bigendian_bytearray )

  int            i, nunit;
  unit          *lsb;
  unit           t;
  unsigned char *ext_end;

  nunit = sizeof(unit);

  lsb = UNIT_PLUS_K(msb_internal, internal_size - 1);
  ext_end = external + (external_byte_size -1);

  while ((internal_size !=0) && (external_byte_size != 0)) {
      t = *UNIT_MINUS_MINUS(lsb);
      for( i=0; ( ( i < nunit) && ( external_byte_size ) ); i++)  {
        *ext_end-- = t%256;
        external_byte_size--;
        t /= 256;
      }
     internal_size--;
  }

  if (external_byte_size) {
    do {
      *ext_end-- = 0;
    }while(--external_byte_size);
  }
  P_LEAVE( P_mpint_to_bigendian_bytearray )
}
/*------------------------------------------------------------------------
  bigendian_bytearray_to_mpint

  INPUT:
        external byte array containing the mp int.
        external_byte_size  size in bytes of the external array.
        bitsize             bit size of the  mp integer.
        msb_internal        msb of the mp_int
        internal_size       current size of the mp_int

  NOTE:

 ----------------------------------------------------------------------*/
void bigendian_bytearray_to_mpint( unsigned char *external,
                                   int external_byte_size,
                                   unsigned long bitsize,
                                   unit *msb_internal,
                                   int internal_size)
{
  P_ENTER( P_bigendian_bytearray_to_mpint )

  int                whole_units, partial_unit_bytes;
  unit              *lsb;
  unsigned char     *ext_end;
  int                i, nunit;
  unit               t;
  unit               mask = (unit) 0 - (unit)1;

  nunit = sizeof(unit);
  lsb = UNIT_PLUS_K(msb_internal, internal_size - 1);
  ext_end = external + external_byte_size - 1;

  whole_units = (bitsize/UNITSIZE > (unsigned int)(external_byte_size/nunit))?
    external_byte_size/nunit : bitsize/UNITSIZE;

  if (internal_size <= whole_units) {
    whole_units = internal_size;
    partial_unit_bytes=0;
  }
  else {
    if (bitsize/UNITSIZE > (unsigned int) external_byte_size/nunit)

      partial_unit_bytes = external_byte_size - (whole_units * nunit);
    else {
      int bits;

      bits = (bitsize - (unsigned long)whole_units*UNITSIZE);
      mask = (unsigned) mask >> (UNITSIZE - bits);

      if (bitsize/UNITSIZE == (unsigned int) external_byte_size/nunit)
        partial_unit_bytes = external_byte_size - (whole_units * nunit);
      else
        partial_unit_bytes = nunit;
    }

  }

  while(whole_units--) {
    t = 0;
    for (i=0; i<nunit; i++) {
      t <<= 8;
      t |= *(ext_end - (nunit - 1 - i));
    }
    ext_end -= nunit;
    external_byte_size -= nunit;
    *UNIT_MINUS_MINUS(lsb) = t;
    internal_size--;
  }
  /* Stage 2 */
  if (partial_unit_bytes) {
    t=0;
    for (i=0; i<partial_unit_bytes; i++) {
      t <<= 8;
      t |= *(ext_end - (partial_unit_bytes - 1 - i));
    }
    *UNIT_MINUS_MINUS(lsb) = (t & mask);
    internal_size--;
  }

  /* Stage 3 */
  if (internal_size) {
    do {
      *UNIT_MINUS_MINUS(lsb)=0;

    }while(--internal_size);
  }
  P_LEAVE( P_bigendian_bytearray_to_mpint )
}









