
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


/****************************************************************************
 **                                                                        **
 **        (C) COPYRIGHT IBM CORP 1997,1999                                **
 **                                                                        **
 **       LICENSED MATERIALS  -  PROPERTY OF IBM                           **
 **                                                                        **
 **       All Rights Reserved                                              **
 **                                                                        **
 **       U.S. Government Users Restricted Rights - Use,                   **
 **       duplication or disclosure restricted by GSA ADP                  **
 **       Schedule Contract with IBM Corp.                                 **
 **                                                                        **
 **       See Copyright Instructions (Form G120-2083)                      **
 **                                                                        **
 **       Origin: RES (IBM Research Division)                              **
 **                                                                        **
 ****************************************************************************
 *                                                                          *
 * Module name:         sha1.c                                              *
 *                                                                          *
 * Descriptive name:    PKA Manager Secure Hash Algorithm Implementation    *
 *                                                                          *
 * Status:              Version 1 Driver 1                                  *
 *                                                                          *
 * Function:            Secure Hash Algorithm SHA-1 Standard Implementation *
 *                      (FIPS 180-1)                                        *
 *                                                                          *
 * Module type:         C source code                                       *
 *                                                                          *
 * Processor:           VisualAgeC++ for OS/2                               *
 *                                                                          *
 *                                                                          *
 * Restrictions:        Simplyfying assumption:  All data to be hashed etc  *
 *                      is of bit length which is a multiple of 8 bits.     *
 *                                                                          *
 *                                                                          *
 * CHANGE-ACTIVITY:     Adapted from Todd Arnold's implementation by        *
 *                      Pankaj Rohatgi with major changes                   *
 *                                                                          *
 *     Date    By   Comments                                                *
 *    -------  ---  ------------------------------------------------------  *
 *  97/04/16   PR   initial implementation                                  *
 *  99/02/18   RP   fixed bug in SHA_Update when the context buffer was     *
 *                  not full, also added some comments in this area         *
 *  99/02/08   jgd  profiling...                                            *
 ****************************************************************************/
 
/*===========================================================================*/
/* Secure Hash Algorithm SHA-1 (FIPS 180-1)                                  */
/* Rewrite from Todd Arnonlds implementation by                              */
/* Pankaj Rohatgi rohatgi@watson.ibm.com with major changes                  */
/* Simplyfying assumption: All data to be hashed etc is of bit length which  */
/* a multiple of 8 bits.                                                     */
/*                                                                           */
/* Pau-Chen Cheng pau@watson.ibm.com modified Pankaj's version a little bit  */
/* to take some short-cuts if the machine is BIG_EDINA; so                   */
/* "extract_four_bytes()" is defined to be an simple macro for BIG_EDIAN     */
/* systems. Also, the loop code in SHA_update() is simplified. Also,         */
/* SHA_compress()'s interface is changed a little bit to cut some data       */
/* copying in SHA_update() and I did loop unfolding in SHA_compress().       */
/*---------------------------------------------------------------------------*/

#include <string.h>

#include "platform.h"
#ifdef __s390__
#define _LINUX_S390_ 1
#ifdef _LINUX_S390_
#undef __BIG_ENDIAN__
#define __BIG_ENDIAN__ 1
#endif
#endif
#include "sha.h"

#ifndef __PROFILE__
#define  __PROFILE__ 0
#endif
#include "profiler.h"

#define f0(x, y, z)  (((x) & (y)) | (~(x) & (z)))
#define f1(x, y, z)  (((x) ^ (y)) ^ (z))
#define f2(x, y, z)  (((x) & ((y) | (z))) | ((y) & (z)))
#define S1(x)  (((x) << 1) | ((x) >> 31))
#define S5(x) (((x) << 5) | ((x) >> 27))
#define S30(x) (((x) << 30) | ((x) >> 2))

/*
  MAGIC CONSTANTS
*/
#define K0 (u_int32)0x5a827999L
#define K1 (u_int32)0x6ed9eba1L
#define K2 (u_int32)0x8f1bbcdcL
#define K3 (u_int32)0xca62c1d6L
#define bigendian_upeek4(b)  (  \
                                (((u_int32) (*(b))) << 24)      |  \
                                (((u_int32) (*((b)+1))) <<  16) |  \
                                (((u_int32) (*((b)+2))) << 8)   |  \
                                (((u_int32) (*((b)+3))))           \
                            )

/*
   The compression function for SHA, uses only the Ibuf for
   data and h0, h1, h2, h3, h4 fileds of the supplied context and
   updates the h's without touching
   anything else.
*/

static void SHAA_Compress(SHA_CTX *CTX, unsigned char* Ibuf)
{


  u_int32 A, B, C, D, E;
  u_int32 temp;
  u_int32 W[80];
  int t;
  u_int32 *WP = W;

  /* Load 'em W[0], W[15] */
#ifdef __BIG_ENDIAN__
  memcpy(W, Ibuf, 64);
#else
#ifdef __LITTLE_ENDIAN__
  {
    unsigned char *buf = Ibuf;
    for (t=0; t < 16; t++)
    {
      W[t] = bigendian_upeek4(buf);
      buf += 4;
    }
  }
#else
faketype please_define_endianness;
#endif
#endif

  /* Init 'em W[16],...,W[80] */
  {
    u_int32 *wt, *wtm3, *wtm8,  *wtm14, *wtm16;

    wt = &W[16];
    wtm3 = wt - 3;
    wtm8 = wt - 8;
    wtm14 = wt - 14;
    wtm16 = wt - 16;

    t = 16;
    do {
      temp = ((((*wtm3++) ^ (*wtm8++)) ^ (*wtm14++)) ^ (*wtm16++));
      temp = S1(temp);
      *wt++ = temp;
      temp = ((((*wtm3++) ^ (*wtm8++)) ^ (*wtm14++)) ^ (*wtm16++));
      temp = S1(temp);
      *wt++ = temp;
      temp = ((((*wtm3++) ^ (*wtm8++)) ^ (*wtm14++)) ^ (*wtm16++));
      temp = S1(temp);
      *wt++ = temp;
      temp = ((((*wtm3++) ^ (*wtm8++)) ^ (*wtm14++)) ^ (*wtm16++));
      temp = S1(temp);
      *wt++ = temp;
    }while(--t);

  }


  A=  CTX->h0;
  B = CTX->h1;
  C = CTX->h2;
  D = CTX->h3;
  E = CTX->h4;

  /* Round 1 */
  t = 4;
  do {

    temp = S5(A) + f0(B,C,D) + E + *WP++ + K0;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f0(B,C,D) + E + *WP++ + K0;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f0(B,C,D) + E + *WP++ + K0;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f0(B,C,D) + E + *WP++ + K0;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f0(B,C,D) + E + *WP++ + K0;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

  }while (--t);

  /* Round 2*/
  t = 4;
  do {

    temp = S5(A) + f1(B,C,D) + E + *WP++ + K1;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f1(B,C,D) + E + *WP++ + K1;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f1(B,C,D) + E + *WP++ + K1;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f1(B,C,D) + E + *WP++ + K1;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f1(B,C,D) + E + *WP++ + K1;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;


  }while (--t);

  /* Round 3*/
  t = 4;
  do {


    temp = S5(A) + f2(B,C,D) + E + *WP++ + K2;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f2(B,C,D) + E + *WP++ + K2;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f2(B,C,D) + E + *WP++ + K2;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f2(B,C,D) + E + *WP++ + K2;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f2(B,C,D) + E + *WP++ + K2;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;


  }while (--t);

  /* Round 4*/
  t = 4;
  do {

    temp = S5(A) + f1(B,C,D) + E + *WP++ + K3;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f1(B,C,D) + E + *WP++ + K3;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f1(B,C,D) + E + *WP++ + K3;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f1(B,C,D) + E + *WP++ +K3;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;

    temp = S5(A) + f1(B,C,D) + E + *WP++ +K3;
    E=D;
    D=C;
    C=S30(B);
    B=A;
    A=temp;



  }while (--t);


  CTX->h0 += A;
  CTX->h1 += B;
  CTX->h2 += C;
  CTX->h3 += D;
  CTX->h4 += E;
}

void SHAA_Init(SHA_CTX *CTX)
{

  P_ENTER( P_SHAA_Init )
  CTX->bytes_in_buffer = 0;
  CTX->Llow = CTX->Lhigh = 0;
  CTX->h0 = (u_int32)0x67452301L;
  CTX->h1 = (u_int32)0xefcdab89L;
  CTX->h2 = (u_int32)0x98badcfeL;
  CTX->h3 = (u_int32)0x10325476L;
  CTX->h4 = (u_int32)0xc3d2e1f0L;
  P_LEAVE( P_SHAA_Init )
}

void SHAA_Update(SHA_CTX *CTX, unsigned char *data, size_t data_size)
{
  P_ENTER( P_SHAA_Update )

  int i;
  int cnt, res = 0 ;

  u_int32 l;

  l = CTX->Llow + data_size;
  if (l < CTX->Llow)
  {
    CTX->Llow = l;
    CTX->Lhigh++;
  }
  else
      CTX->Llow = l;

  /* check to see if there is there any room left in the buffer */
  if ((i = 64 - CTX->bytes_in_buffer) <= 64)
  {
    /*
     * there's room in the buffer, so now check to see if we can
     * fit all of the passed-in data there without filling the buffer
     */
    if (data_size < i)
    {
       memcpy(&(CTX->byte_buffer[CTX->bytes_in_buffer]), data, data_size);
       CTX->bytes_in_buffer += data_size;

       /*
        * we don't need to do anything else until the buffer is full,
        * so just return now
        */
       return;
    }
    else
    {
       /* fill up and then compress the buffer */
       memcpy(&(CTX->byte_buffer[CTX->bytes_in_buffer]), data, i);
       data += i;
       data_size -= i;
       SHAA_Compress(CTX, CTX->byte_buffer);
    }
  }
  cnt = data_size >> 6 ;    /* data_size / 64 ; */
  res = data_size & 63U ;   /* data_size % 64 ; */
  for ( ; cnt > 0 ; --cnt)
  {
    SHAA_Compress(CTX, data);
    data += 64;
  }

  /* make sure to keep the left-overs in the buffer for next time */
  if (res > 0) {
    memcpy(CTX->byte_buffer, data, res);
  }
  CTX->bytes_in_buffer = res;

  P_LEAVE( P_SHAA_Update )
}

static void extract_four_bytes(unsigned char *c, u_int32 i)
{
  c += 3;
  *c-- = (u_int8) i;
  i >>= 8;
  *c-- = (u_int8) i;
  i >>= 8;
  *c-- = (u_int8) i;
  i >>= 8;
  *c = (u_int8) i;
}

int  SHAA_Final(SHA_CTX *CTX, unsigned char *digest)
{
  P_ENTER( P_SHAA_Final )

  int retval = 0;
  int j = CTX->bytes_in_buffer;

  /* Note that j will have to be less than 63 o/w we would have processed
       the input anyway
  */
  CTX->byte_buffer[j++] = 0x80;
  memset(&(CTX->byte_buffer[j]), 0, 64-j);

  /* Prepare everything for last round */

  if (j > 56)
  {
    /*
      Additional round needed, do it and prepare for last round
    */
    SHAA_Compress(CTX, CTX->byte_buffer);
    memset(CTX->byte_buffer, 0, 64);
  }

  /* Get length field in */
  {
    u_int32 lowtop3;
    u_int32 hightop3;

    lowtop3 = CTX->Llow >> 29;
    hightop3 = CTX->Lhigh >> 29;

    if (hightop3)
      retval = -1;
    CTX->Llow <<= 3;
    CTX->Lhigh <<= 3;
    CTX->Lhigh |= lowtop3;

    extract_four_bytes(CTX->byte_buffer + 56, CTX->Lhigh);
    extract_four_bytes(CTX->byte_buffer + 60, CTX->Llow);

  }

  /* Last Compress */
  SHAA_Compress(CTX, CTX->byte_buffer);
  extract_four_bytes(digest, CTX->h0);
  extract_four_bytes(digest+4, CTX->h1);
  extract_four_bytes(digest+8, CTX->h2);
  extract_four_bytes(digest+12, CTX->h3);
  extract_four_bytes(digest+16, CTX->h4);
  memset(CTX, 0, sizeof(SHA_CTX));

  P_LEAVE( P_SHAA_Final )
  return retval;
}

/*
  G(t,c) as described in the appendix in DSA algorithm
  t[0] ... t[4] holds the IV
  r[0] ... r[4] holds the result of one application of the compress function
  c is the input to the function as a left justified data array of b bytes and
  internally G will pad it with 0's to the compress function's key size
  (512 bit)
*/


void dsa_G_from_sha(const u_int32 *t, unsigned char *c, int b,  u_int32 *r)
{
  P_ENTER( P_dsa_G_from_sha )

  SHA_CTX ctx;
  int i;

  ctx.h0 = t[0];
  ctx.h1 = t[1];
  ctx.h2 = t[2];
  ctx.h3 = t[3];
  ctx.h4 = t[4];

  if (b < 0)
    return;
  if (b > 64)
    b = 64;

  for (i=0; i<b; i++)
    ctx.byte_buffer[i] = *c++;
  for (i=b; i<64; i++)
    ctx.byte_buffer[i]=0;

  SHAA_Compress(&ctx, ctx.byte_buffer);

  r[0] = ctx.h0;
  r[1] = ctx.h1;
  r[2] = ctx.h2;
  r[3] = ctx.h3;
  r[4] = ctx.h4;

  memset(&ctx, 0, sizeof(SHA_CTX));

  P_LEAVE( P_dsa_G_from_sha )
}
